import java.net.*;
import java.awt.Event;
import java.awt.Image;
import java.awt.Color;
import java.awt.Graphics;
import java.applet.AudioClip;

public class Animator extends java.applet.Applet implements Runnable
{
  // Dclaration des variables

  // Matrice d'images
  Image animPics[] = new Image[8];

  // Chemins des images
  Image currentImg;

  // Le thread pour limiter les clignotements
  Thread runner;

  // Position d'affichage des images
  int x;
  int y = size().height / 2;

  // Les sons
  AudioClip voice;
  AudioClip weapon;

  public void init()
  {
    // On charge tous les fichiers ncessaires en mmoire

    String animSrc[] = { "walk.gif", "walk2.gif", "front.gif", "front2.gif", "killed.gif", "killed2.gif", "says.gif", "says2.gif" };
    for (int i = 0; i < animPics.length; i++)
      animPics[i] = getImage(getCodeBase(), "gfx/" + animSrc[i]);
    voice = getAudioClip(getCodeBase(), "gfx/voice.au");
    weapon = getAudioClip(getCodeBase(), "gfx/weapon.au");
  }

  public void start()
  {
    if (runner == null)
    {
      runner = new Thread(this);
      runner.start();
    }
  }

  public void stop()
  {
    runner = null;
  }

  public void run()
  {
    setBackground(Color.white);

    while (runner != null)
    {
      // Dplacement au milieu de l'applet
      kennyRun(0, (size().width / 2) - 16);

      // S'arrter et cligner des yeux
      kennyBlink(5);

      // Kenny meurt
      kennyDie();

      // Kyle parle
      kyleSays(11);
    }
  }

  public void kennyRun(int start, int end)
  {
    for (int i = start; i < end; i += 5)
    {
      x = i;
      if (currentImg == animPics[0])
        currentImg = animPics[1];
      else
        currentImg = animPics[0];
      repaint();
      pause(150);
    }
  }

  public void kennyBlink(int numTimes)
  {
    for (int i = numTimes; i > 0; i--)
    {
      currentImg = animPics[2];
      repaint();
      pause(300);
      currentImg = animPics[3];
      repaint();
      pause(300);
    }
  }

  public void kennyDie()
  {
    if (runner != null ) weapon.play();
    currentImg = animPics[4];
    repaint();
    pause(800);
    currentImg = animPics[5];
    repaint();
    pause(1000);
  }

  public void kyleSays(int numTimes)
  {
    if (runner != null ) voice.play();
    for (int i = numTimes; i > 0; i--)
    {
      currentImg = animPics[6];
      repaint();
      pause(150);
      currentImg = animPics[7];
      repaint();
      pause(150);
    }
    currentImg = animPics[6];
    repaint();
    pause(1000);
  }

  public void pause(int time)
  {
    try
    {
      Thread.sleep(time);
    } catch (InterruptedException e) { }
  }

  public void paint(Graphics g)
  {
    if (currentImg != null)
      g.drawImage(currentImg, x, y, this);
  }

  public String getAppletInfo()
  {
    return("Kenny's Death 1998 Romain GUY");
  }

  public boolean mouseEnter(Event evt, int x, int y)
  {
    getAppletContext().showStatus("Kenny's Death 1998 Romain GUY");
    return true;
  }

  public boolean mouseDown(Event evt, int x, int y)
  {
    try
    {
      getAppletContext().showDocument(new URL("http://www.chez.com/powerteam"));
    }
    catch (MalformedURLException e)
    {
    }
    return true;
  }
}
